package alc.appnaranja.presentador;


public interface IPresentadorDondeEstamos {

	/**
	 * Se realizan todas las operaciones necesarias para mostrar la VistaDondeEstamos.
	 */
	public void mostrarVistaDondeEstamos();
	
	/**
	 * Carga del modelo la lista de peluqueras.
	 */
	public void cargarListaPeluquerias();
	
	/**
	 * Presenta en la vista la lista de peluqueras.
	 */
	public void presentarListaPeluquerias();
	
	/**
	 * Se cargan del modelo los datos de la peluquera seleccionada
	 */
	public void cargarDatosPeluqueria();
	
	/**
	 * Se presentan en la vista los datos de la peluquera (Imagen y descripcin).
	 */
	public void presentarDatosPeluqueria();
	
	/**
	 * Lanza la actividad Mapa de la aplicacin, donde aparece un mapa con la posicin de la peluquera.
	 */
	public void lanzarMapa();

}
