package alc.appnaranja.presentador;

import android.app.Activity;

public interface IPresentadorPrincipal {

	/**
	 * Lanza la actividad Donde Estamos de la aplicacin, donde se puede ver la ubicacin de las distintas peluqueras.
	 */
	public void lanzarDondeEstamos();
	
	/**
	 * Lanza la actividad Pedir Cita de la aplicacin, donde se puede pedir cita.
	 */
	public void lanzarPedirCita();
	
	/**
	 * Lanza la actividad Mis Citas de la aplicacin, donde se pueden ver las citas que el usuario ha pedido.
	 */
	public void lanzarMisCitas();
	
	/**
	 * Lanza la actividad Ayuda de la aplicacin, donde se proporciona ayuda para el uso de la aplicacin.
	 */
	public void lanzarAyuda();
	
	/**
	 * Lanza la actividad Info de la aplicacin, donde se proporciona informacin de la aplicacin (versin, creadores...)
	 */
	public void lanzarInfo();
	
	/**
	 * Lanza la actividad Presentacin de la aplicacin, donde se proporciona una presentacin de la empresa.
	 */
	public void lanzarPresentacion();
	
	/**
	 * Lanza la actividad Configuracin de la aplicacin, donde se puede cambiar la configuracion de la aplicacin.
	 */
	public void lanzarConfiguracion();
	
	/**
	 * Lanza el navegador del mvil con una url especfica.
	 * @param url URL de la pgina a la que se acceder
	 * @param a Actividad que lanza dicha url
	 */
	public void lanzarURL(String url, Activity a);
	
	/**
	 * Actualiza las preferencias por las seleccionadas por el usuario.
	 */
	public void actualizaPreferencias();
}
