package alc.appnaranja.vista;


public interface IVistaDondeEstamos {
	
	/**
	 * Actualiza la lista de peluqueras de la vista
	 * @param lista Listado de peluqueras que se muestra en la vista.
	 */
	public void setListaPeluquerias(Object lista);
	
	/**
	 * Obtiene la peluquera que ha seleccionado el usuario en la vista
	 * @return Nombre de la peluquera seleccionada por el usuario
	 */
	public String getPeluqueriaSeleccionada();
	/**
	 * Actualiza la imagen de la peluquera que aparece en la vista
	 * @param imagen Imagen de la peluquera
	 */
	public void setImagenPeluqueria(Object imagen);
	/**
	 * Actualiza el texto de la descripcin de la peluquera
	 * @param texto Texto de la descripcin de la peluquera
	 */
	public void setTextoDescripcionPeluqueria(String texto);
	
	/**
	 * Muestra una alerta si ha habido algn error.
	 * @param titulo Ttulo de la alerta.
	 */
	public void mostrarAlerta(String titulo);
	
	/**
	 * Muestra una barra de progreso para indicar que se est haciendo alguna operacin con la nube.
	 * @param mensaje mensaje que se muestra mientras se carga
	 */
	public void mostrarProgreso(String mensaje);
	
	/**
	 * Elimina la barra de progreso.
	 */
	public void eliminarProgreso();

	
}
