package alc.appnaranja.vista;


public interface IVistaPedirCita1 {
	
	/**
	 * Obtiene el nombre introducido por el usuario en el campo nombre
	 * @return Nombre introducido por el usuario
	 */
	public String getTextoNombre();
	
	/**
	 * Obtiene el telefono introducido por el usuario en el campo telefono
	 * @return Telefono introducido por el usuario
	 */
	public String getTextoTelefono();
	
	/**
	 * Obtiene el estado del botn Hombre de la vista
	 * @return Estado del botn Hombre
	 */
	public boolean getEstadoBotonHombre();
	
	/**
	 * Obtiene el estado del botn Mujer de la vista
	 * @return Estado del botn Mujer
	 */
	public boolean getEstadoBotonMujer();
	
	/**
	 * Actualiza la lista de peluqueras de la vista
	 * @param lista Listado de peluqueras que se muestra en la vista.
	 */
	public void setListaPeluquerias(Object lista);
	
	/**
	 * Obtiene la peluquera que ha seleccionado el usuario en la vista
	 * @return Nombre de la peluquera seleccionada por el usuario
	 */
	public String getPeluqueriaSeleccionada();
	
	/**
	 * Muestra una alerta si ha habido algn error.
	 * @param titulo Ttulo de la alerta.
	 */
	public void mostrarAlerta(String titulo);
	
	/**
	 * Muestra una barra de progreso para indicar que se est haciendo alguna operacin con la nube.
	 * @param mensaje mensaje que se muestra mientras se carga
	 */
	public void mostrarProgreso(String mensaje);
	
	/**
	 * Elimina la barra de progreso.
	 */
	public void eliminarProgreso();

}
