package alc.appnaranja.vista;


public interface IVistaPedirCita3 {
	/**
	 * Actulaiza los das disponibles en la vista
	 * @param dias Dias disponibles
	 */
	public void setDiasDisponibles(Object dias);
	
	/**
	 * Actualiza las horas disponibles en la vista
	 * @param horas Horas disponibles en la vista
	 */
	public void setHorasDisponibles(Object horas);
	
	/**
	 * Obtiene el da seleccionado por el usuario en la vista
	 * @return Da seleccionado en la vista
	 */
	public String getDia();
	
	/**
	 * Obtiene la hora seleccionada en la vista
	 * @return Hora seleccionada en la vita
	 */
	public String getHora();
	/**
	 * Muestra una alerta si ha habido algn error.
	 * @param titulo Ttulo de la alerta.
	 */
	public void mostrarAlerta(String titulo);
	
	/**
	 * Muestra una barra de progreso para indicar que se est haciendo alguna operacin con la nube.
	 * @param mensaje mensaje que se muestra mientras se carga
	 */
	public void mostrarProgreso(String mensaje);
	
	/**
	 * Elimina la barra de progreso.
	 */
	public void eliminarProgreso();

}
